//FarbeSuchen_305d.js
// 12.08.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Dient zum Aufspren von Zuweisungen eines bestimmten Farbfeldes

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Programmversion feststellen
var appVers = app.version[0];
if (appVers != 5) {
	if (appVers == 4) {
		alert ("Fr InDesign CS2\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else if (appVers == 6) {
		alert ("Fr InDesign CS4\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else {
		alert ("Dieses Script nur mit InDesign CS3 benutzen.", "Achtung");
	}
	exit();
}

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

curDoc = app.documents[0];

// die benutzerdefinierten Farbfelder auflisten
var allSwatches = curDoc.swatches;
var curSwatch, cName;
var colorList = new Array();
for (var i=0; i<allSwatches.length; i++) {
	curSwatch = allSwatches.item(i);
	cName = curSwatch.name;
	if (cName != "None" && cName != "Black" && cName != "Paper" && cName != "Registration") {
		colorList.push(cName);
	}
}

// Dialoge, welche eventuell im Speicher geblieben sind, lschen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// die zu suchende Farbe verlangen
var aDialog = app.dialogs.add({name:"Vorhandene Farbfelder", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Die zu suchende Farbe whlen"});
				var colorNames = dropdowns.add({stringList:colorList, selectedIndex:0, minWidth:130});
			}
		}
	}
}

// den Dialog zeigen
if (aDialog.show() == true) {
	var selColor, aOffset, aTint;
	// die Wahl des Anwenders bernehmen
	// der Name der Farbe ist das Element 'selectedIndex' der Liste 'colorList'
	selColor = colorList[colorNames.selectedIndex];
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

//--- die Absatzformate auflisten ...---//
var allParaStyles = curDoc.paragraphStyles;
var nParaStyles = allParaStyles.length;

// eine Schleife durch die Liste (der Zhler beginnt bei "1", 
// um "[Kein Absatzformat]" zu vermeiden)
var curList, newList, tmpList, defList;
var curProps, newString;
var defString = "";
var pCtr = 0;
var curName, unc, ungc, stc, stgc;
for (var i=1; i<nParaStyles; i++) {
	curList = new Array ();
	curProps = allParaStyles[i].properties;
	defList = testParaStyles(curProps);
	if (defList.length > 0) {
		pCtr++;
		curName = allParaStyles[i].name;
		curList.push("Absatzformat \"" + curName + "\":");
		newList = curList.concat(defList);
		newString = newList.join("");
		defString = defString + newString + "\r";
	}
}

//--- die Absatzformatgruppen auflisten ...---//
var allGroups = curDoc.paragraphStyleGroups;
var nParaStyleGroups = allGroups.length;
var curGroup, curParaStyles, nParaStyles;
for (var i=0; i<nParaStyleGroups; i++) {
	curGroup = allGroups[i];
	curParaStyles = curGroup.allParagraphStyles;
	nParaStyles = curParaStyles.length;
	for (var k=0; k<nParaStyles; k++) {
		curProps = curParaStyles[k].properties;
		defList = testParaStyles(curProps);
		if (defList.length > 0) {
			pCtr++;
			curList = new Array ();
			curName = curParaStyles[k].name;
			curGroupName = curParaStyles[k].parent.name;
			curList.push("Absatzformat \"" + curName + "\" (" + curGroupName + "):");
			newList = curList.concat(defList);
			newString = newList.join("");
			defString = defString + newString + "\r";
		}
	}
}

// die Funktion, welche die Absatzformate untersucht
function testParaStyles(curProps) {
	tmpList = new Array ();
	if (curProps.fillColor != undefined) {
		if (curProps.fillColor.name == selColor) {
			tmpList.push("  > Zeichenfarbe");
		}
	}
	if (curProps.strokeColor != undefined) {
		if (curProps.strokeColor.name == selColor) {
			tmpList.push("  > Konturfarbe");
		}
	}
	if (curProps.ruleAboveColor != undefined) {
		if (curProps.ruleAboveColor.name == selColor) {
			tmpList.push("  > Linie darber");
		}
	}
	if (curProps.ruleAboveGapColor != undefined) {
		if (curProps.ruleAboveGapColor.name == selColor) {
			tmpList.push("  > Linie darber (Lcke)");
		}
	}
	if (curProps.ruleBelowColor != undefined) {
		if (curProps.ruleBelowColor.name == selColor) {
			tmpList.push("  > Linie darunter");
		}
	}
	if (curProps.ruleBelowGapColor != undefined) {
		if (curProps.ruleBelowGapColor.name == selColor) {
			tmpList.push("  > Linie darunter (Lcke)");
		}
	}
	if (curProps.underlineColor != undefined) {
		if (curProps.underlineColor.name == selColor) {
			tmpList.push("  > Unterstreichung");
		}
	}
	if (curProps.underlineGapColor != undefined) {
		if (curProps.underlineGapColor.name == selColor) {
			tmpList.push("  > Unterstreichung (Lcke)");
		}
	}
	if (curProps.strikeThroughColor != undefined) {
		if (curProps.strikeThroughColor.name == selColor) {
			tmpList.push("  > Durchstreichung");
		}
	}
	if (curProps.strikeThroughGapColor != undefined) {
		if (curProps.strikeThroughGapColor.name == selColor) {
			tmpList.push("  > Durchstreichung (Lcke)");
		}
	}
	return tmpList;
}

//--- die Zeichenformate auflisten ...---//
var allCharStyles = curDoc.characterStyles;
var nCharStyles = allCharStyles.length;

// eine Schleife durch die Liste (der Zhler beginnt bei "1", 
// um "[Ohne]" zu vermeiden)
var cCtr = 0;
for (var i=1; i<nCharStyles; i++) {
	curList = new Array ();
	curProps = allCharStyles[i].properties;
	defList = testCharStyles(curProps);
	if (defList.length > 0) {
		cCtr++;
		curName = allCharStyles[i].name;
		curList.push("Zeichenformat \"" + curName + "\":");
		newList = curList.concat(defList);
		newString = newList.join("");
		defString = defString + newString + "\r";
	}
}

//--- die Zeichenformatgruppen auflisten ...---//
var allGroups = curDoc.characterStyleGroups;
var nCharStyleGroups = allGroups.length;
var curGroup, curCharStyles, nCharStyles;
for (var i=0; i<nCharStyleGroups; i++) {
	curGroup = allGroups[i];
	curCharStyles = curGroup.allCharacterStyles;
	nCharStyles = curCharStyles.length;
	for (var k=0; k<nCharStyles; k++) {
		curProps = curCharStyles[k].properties;
		defList = testCharStyles(curProps);
		if (defList.length > 0) {
			cCtr++;
			curList = new Array ();
			curName = curCharStyles[k].name;
			curGroupName = curCharStyles[k].parent.name;
			curList.push("Zeichenformat \"" + curName + "\" (" + curGroupName + "):");
			newList = curList.concat(defList);
			newString = newList.join("");
			defString = defString + newString + "\r";
		}
	}
}

// die Funktion, welche die Zeichenformate untersucht
function testCharStyles(curProps) {
	tmpList = new Array ();
	try {
		if (curProps.fillColor.name == selColor) {
			tmpList.push("  > Zeichenfarbe");
		}
	}
	catch (e) {
	}
	try {
		if (curProps.strokeColor.name == selColor) {
			tmpList.push("  > Konturfarbe");
		}
	}
	catch (e) {
	}
	try {
		unc = curProps.underlineColor;
		if (unc.name == selColor) {
			tmpList.push("  > Unterstreichung");
		}
	}
	catch (e) {
	}
	try {
		ungc = curProps.underlineGapColor;
		if (ungc.name == selColor) {
			tmpList.push("  > Unterstreichung (Lcke)");
		}
	}
	catch (e) {
	}
	try {
		stc = curProps.strikeThroughColor;
		if (stc.name == selColor) {
			tmpList.push("  > Durchstreichung");
		}
	}
	catch (e) {
	}
	try {
		stgc = curProps.strikeThroughGapColor;
		if (stgc.name == selColor) {
			tmpList.push("  > Durchstreichung (Lcke)");
		}
	}
	catch (e) {
	}
	return tmpList;
}

//--- die Objektstile auflisten ...---//
var allObjectStyles = curDoc.objectStyles;
var nObjStyles = allObjectStyles.length;

// eine Schleife durch die Liste (der Zhler beginnt bei "1", 
// um "[Ohne]" zu vermeiden)
var oCtr = 0;
for (var i=1; i<nObjStyles; i++) {
	curStyle = allObjectStyles[i];
	curProps = curStyle.properties;
	defList = testObjStyles(curStyle, curProps);
	if (defList.length > 0) {
		oCtr++;
		curList = new Array ();
		curName = allObjectStyles[i].name;
		curList.push("Objektstil \"" + curName + "\":");
		newList = curList.concat(defList);
		newString = newList.join("");
		defString = defString + newString + "\r";
	}
}

//--- die Objektstilgruppen auflisten ...---//
var allGroups = curDoc.objectStyleGroups;
var nObjStyleGroups = allGroups.length;
var curGroup, curObjStyles, nObjStyles;
for (var i=0; i<nObjStyleGroups; i++) {
	curGroup = allGroups[i];
	curObjStyles = curGroup.allObjectStyles;
	nObjStyles = curObjStyles.length;
	for (var k=0; k<nObjStyles; k++) {
		curStyle = curObjStyles[k];
		curProps = curObjStyles[k].properties;
		defList = testObjStyles(curStyle, curProps);
		if (defList.length > 0) {
			cCtr++;
			curList = new Array ();
			curName = curObjStyles[k].name;
			curGroupName = curObjStyles[k].parent.name;
			curList.push("Objektstil \"" + curName + "\" (" + curGroupName + "):");
			newList = curList.concat(defList);
			newString = newList.join("");
			defString = defString + newString + "\r";
		}
	}
}

// die Funktion, welche die Objektstile untersucht
function testObjStyles(curStyle, curProps) {
	tmpList = new Array ();
	try {
		if (curProps.fillColor.name == selColor) {
			tmpList.push("  > Fllfarbe");
		}
	}
	catch (e) {
	}
	try {
		if (curProps.strokeColor.name == selColor) {
			tmpList.push("  > Kontur");
		}
	}
	catch (e) {
	}
	try {
		if (curProps.gapColor.name == selColor) {
			tmpList.push("  > Lcke");
		}
	}
	catch (e) {
	}
	try {
		curTransProps = curStyle.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpList.push("  > Schatten");
		}
		else {
			curTransProps = curStyle.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpList.push("  > Schatten");
			}
			else {
				curTransProps = curStyle.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpList.push("  > Schatten");
				}
				else {
					curTransProps = curStyle.contentTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpList.push("  > Schatten");
					}
				}
			}
		}
	}
	catch (e) {
	}
	return tmpList;
}

//--- die Tabellenformate auflisten ...---//
var allTableStyles = curDoc.tableStyles;
var nTableStyles = allTableStyles.length;

// eine Schleife durch die Liste (der Zhler beginnt bei "1", 
// um "Kein Tabellenformat" zu vermeiden)
var tbsCtr = 0;
curList = new Array ();
for (var i=1; i<nTableStyles; i++) {
	curStyle = allTableStyles[i];
	if (testTableStyles(curStyle)) {
		tbsCtr++;
		curList.push("\"" + curStyle.name + "\"");
	}
}
if (curList.length > 0) {
	var newString = curList.join(", ");
	if (curList.length == 1) {
		defString = defString + "Tabellenformat:\t" + newString + "\r";
	}
	else {
		defString = defString + "Tabellenformate:\t" + newString + "\r";
	}
}

//--- die Tabellenformatgruppen auflisten ...---//
var allGroups = curDoc.tableStyleGroups;
var nTableStyleGroups = allGroups.length;
var curGroup, curTableStyles;
for (var i=0; i<nTableStyleGroups; i++) {
	curGroup = allGroups[i];
	curTableStyles = curGroup.allTableStyles;
	nTableStyles = curTableStyles.length;
	for (var k=0; k<nTableStyles; k++) {
		curStyle = curTableStyles[k];
		if (testTableStyles(curStyle)) {
			tbsCtr++;
			curList = new Array ();
			curName = curTableStyles[k].name;
			curGroupName = curTableStyles[k].parent.name;
			curList.push("Tabellenformat \"" + curName + "\" (" + curGroupName + ")");
			newList = curList.concat(defList);
			newString = newList.join("");
			defString = defString + newString + "\r";
		}
	}
}

// die Funktion, welche die Tabellenformate untersucht
function testTableStyles(curStyle) {
	if (curStyle.topBorderStrokeColor != undefined) {
		if (curStyle.topBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.leftBorderStrokeColor != undefined) {
		if (curStyle.leftBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.bottomBorderStrokeColor != undefined) {
		if (curStyle.bottomBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.rightBorderStrokeColor != undefined) {
		if (curStyle.rightBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.startColumnFillColor != undefined) {
		if (curStyle.startColumnFillColor.name == selColor) { return true; }}
	if (curStyle.endColumnFillColor != undefined) {
		if (curStyle.endColumnFillColor.name == selColor) { return true; }}
	if (curStyle.startRowFillColor != undefined) {
		if (curStyle.startRowFillColor.name == selColor) { return true; }}
	if (curStyle.endRowFillColor != undefined) {
		if (curStyle.endRowFillColor.name == selColor) { return true; }}
	if (curStyle.startColumnStrokeColor != undefined) {
		if (curStyle.startColumnStrokeColor.name == selColor) { return true; }}
	if (curStyle.endColumnStrokeColor != undefined) {
		if (curStyle.endColumnStrokeColor.name == selColor) { return true; }}
	if (curStyle.startRowStrokeColor != undefined) {
		if (curStyle.startRowStrokeColor.name == selColor) { return true; }}
	if (curStyle.endRowStrokeColor != undefined) {
		if (curStyle.endRowStrokeColor.name == selColor) { return true; }}
	if (curStyle.topBorderStrokeGapColor != undefined) {
		if (curStyle.topBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.leftBorderStrokeGapColor != undefined) {
		if (curStyle.leftBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.bottomBorderStrokeGapColor != undefined) {
		if (curStyle.bottomBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.rightBorderStrokeGapColor != undefined) {
		if (curStyle.rightBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.startColumnStrokeGapColor != undefined) {
		if (curStyle.startColumnStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.endColumnStrokeGapColor != undefined) {
		if (curStyle.endColumnStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.startRowStrokeGapColor != undefined) {
		if (curStyle.startRowStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.endRowStrokeGapColor != undefined) {
		if (curStyle.endRowStrokeGapColor.name == selColor) { return true; }}
	{ return false; }
}

//--- die Zellenformate auflisten ...---//
curList = new Array ();
var allCellStyles = curDoc.cellStyles;
var nCellStyles = allCellStyles.length;

// eine Schleife durch die Liste (der Zhler beginnt bei "1", 
// um "[Ohne]" zu vermeiden)
var cellCtr = 0;
curList = new Array ();
for (var i=1; i<nCellStyles; i++) {
	curStyle = allCellStyles[i];
	if (testCellStyles(curStyle)) {
		cellCtr++;
		curList.push("\"" + curStyle.name + "\"");
	}
}
if (curList.length > 0) {
	var newString = curList.join(", ");
	if (curList.length == 1) {
		defString = defString + "Zellenformat:\t" + newString + "\r";
	}
	else {
		defString = defString + "Zellenformate:\t" + newString + "\r";
	}
}

//--- die Zellenformatgruppen auflisten ...---//
var allGroups = curDoc.cellStyleGroups;
var nCellStyleGroups = allGroups.length;
var curGroup, curCellStyles, nCellStyles;
for (var i=0; i<nCellStyleGroups; i++) {
	curGroup = allGroups[i];
	curCellStyles = curGroup.allCellStyles;
	nCellStyles = curCellStyles.length;
	for (var k=0; k<nCellStyles; k++) {
		curStyle = curCellStyles[k];
		if (testCellStyles(curStyle)) {
			tbsCtr++;
			curList = new Array ();
			curName = curCellStyles[k].name;
			curGroupName = curCellStyles[k].parent.name;
			curList.push("Zellenformat \"" + curName + "\" (" + curGroupName + ")");
			newList = curList.concat(defList);
			newString = newList.join("");
			defString = defString + newString + "\r";
		}
	}
}

// die Funktion, welche die Zellenformate untersucht
function testCellStyles(curStyle) {
	if (curStyle.fillColor != undefined) {
		if (curStyle.fillColor.name == selColor) { return true; }}
	if (curStyle.leftEdgeStrokeColor != undefined) { 
		if (curStyle.leftEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.topEdgeStrokeColor != undefined) {
		if (curStyle.topEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.bottomEdgeStrokeColor != undefined) {
		if (curStyle.bottomEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.rightEdgeStrokeColor != undefined) {
		if (curStyle.rightEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.diagonalLineStrokeColor != undefined) {
		if (curStyle.diagonalLineStrokeColor.name == selColor) { return true; }}
	if (curStyle.topEdgeStrokeGapColor != undefined) {
		if (curStyle.topEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.leftEdgeStrokeGapColor != undefined) {
		if (curStyle.leftEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.bottomEdgeStrokeGapColor != undefined) {
		if (curStyle.bottomEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.rightEdgeStrokeGapColor != undefined) {
		if (curStyle.rightEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.diagonalLineStrokeGapColor != undefined) {
		if (curStyle.diagonalLineStrokeGapColor.name == selColor) { return true; }}
	return false;
}

// die Abstze und die 'textStyleRanges' prfen
var allStories = curDoc.stories;
var nStories = allStories.length;
var tsr, nTsr, tsrFills, tsrStrks;
var tCtr = nCtr = iCtr = 0;
var raf, rag;
var rafCtr = ragCtr = rafgCtr = 0;
var rbf, rbg;
var rbfCtr = rbgCtr = rbfgCtr = 0;
var aFill, aStrk, fCtr;
var curInsPoint;
for (var i=0; i<nStories; i++) {
	curStory = allStories[i];
	// die Absatzlinien
	allParas = curStory.paragraphs;
	nParas = allParas.length;
	for (var j=0; j<nParas; j++) {
		raf = rag = rbf = rbg = false;
		curProps = allParas[j].properties;
		if (curProps.ruleAboveColor != undefined) {
			if (curProps.ruleAboveColor.name == selColor) {
				raf = checkParaRule(curProps, "ra", "full");
			}
		}
		if (curProps.ruleAboveGapColor != undefined) {
			if (curProps.ruleAboveGapColor.name == selColor) {
				rag = checkParaRule(curProps, "ra", "gap");
			}
		}
		if (raf && rag) { rafgCtr++; }
		else if (raf && !rag) { rafCtr++; }
		else if (!raf && rag) { ragCtr++; }
		if (curProps.ruleBelowColor != undefined) {
			if (curProps.ruleBelowColor.name == selColor) {
				rbf = checkParaRule(curProps, "rb", "full");
			}
		}
		if (curProps.ruleBelowGapColor != undefined) {
			if (curProps.ruleBelowGapColor.name == selColor) {
				rbg = checkParaRule(curProps, "rb", "gap");
			}
		}
		if (rbf && rbg) { rbfgCtr++; }
		else if (rbf && !rbg) { rbfCtr++; }
		else if (!rbf && rbg) { rbgCtr++; }
	}
	// normaler Text
	tsr = curStory.textStyleRanges;
	nTsr = tsr.length;
	if (nTsr > 0) {
		tsrFills = tsr.everyItem().fillColor;
		tsrStrks = tsr.everyItem().strokeColor;
		tsrUnder = tsr.everyItem().underlineColor;
		tsrUndGp = tsr.everyItem().underlineGapColor;
		tsrStrTh = tsr.everyItem().strikeThroughColor;
		tsrStrGp = tsr.everyItem().strikeThroughGapColor;
		xCtr = examRanges(nTsr, tsrFills, tsrStrks, tsrUnder, tsrUndGp, tsrStrTh, tsrStrGp);
		tCtr = tCtr+xCtr;
		// Fussnoten
		nNotes = curStory.footnotes.length;
		if (nNotes > 0) {
			for (var k=0; k<nNotes; k++) {
				tsr = curStory.footnotes[k].texts[0].textStyleRanges;
				nTsr = tsr.length;
				tsrFills = tsr.everyItem().fillColor;
				tsrStrks = tsr.everyItem().strokeColor;
				tsrUnder = tsr.everyItem().underlineColor;
				tsrUndGp = tsr.everyItem().underlineGapColor;
				tsrStrTh = tsr.everyItem().strikeThroughColor;
				tsrStrGp = tsr.everyItem().strikeThroughGapColor;
				xCtr = examRanges(nTsr, tsrFills, tsrStrks, tsrUnder, tsrUndGp, tsrStrTh, tsrStrGp);
				nCtr = nCtr+xCtr;
			}
		}
	}
	else {
		curInsPoint = curStory.insertionPoints[0];
		for (var m=0; m<1; m++) {
			if (curInsPoint.fillColor != undefined) {
				if (curInsPoint.fillColor.name == selColor) { iCtr++; break; }}
			if (curInsPoint.strokeColor != undefined) {
				if (curInsPoint.strokeColor.name == selColor) { iCtr++; break; }}
			if (curInsPoint.underlineColor != undefined) {
				if (curInsPoint.underlineColor.name == selColor) { iCtr++; break; }}
			if (curInsPoint.strikeThroughColor != undefined) {
				if (curInsPoint.strikeThroughColor.name == selColor) { iCtr++; break; }}
			if (curInsPoint.underlineGapColor != undefined) {
				if (curInsPoint.underlineGapColor.name == selColor) { iCtr++; break; }}
			if (curInsPoint.strikeThroughGapColor != undefined) {
				if (curInsPoint.strikeThroughGapColor.name == selColor) { iCtr++; break; }}
		}
	}
}

function checkParaRule(curProps, rPos, rType) {
	paraParent = curProps.appliedParagraphStyle;
	paraName   = paraParent.name;
	if (paraName[0] == "[") {
		return true;
	}
	else {
		try {
			if (rPos == "ra") {
				if (rType == "full") {
					if (paraParent.ruleAboveColor != undefined) {
						if (paraParent.ruleAboveColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
				else {
					if (paraParent.ruleAboveGapColor != undefined) {
						if (paraParent.ruleAboveGapColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
			}
			else {
				if (rType == "full") {
					if (paraParent.ruleBelowColor != undefined) {
						if (paraParent.ruleBelowColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
				else {
					if (paraParent.ruleBelowGapColor != undefined) {
						if (paraParent.ruleBelowGapColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
			}
		}
		catch (e) {
		}
	}
}

function examRanges(nTsr, tsrFills, tsrStrks, tsrUnder, tsrUndGp, tsrStrTh, tsrStrGp) {
	var xCtr = 0;
	for (var j=nTsr-1; j>-1; j--) {
		try {
			for (var m=0; m<1; m++) {
				if (tsrFills[j].name == selColor) {
					xCtr++;
					break;
				}
				if (tsrStrks[j].name == selColor) {
					xCtr++;
					break;
				}
				if (tsrUnder[j].name == selColor) {
					xCtr++;
					break;
				}
				if (tsrUndGp[j].name == selColor) {
					xCtr++;
					break;
				}
				if (tsrStrTh[j].name == selColor) {
					xCtr++;
					break;
				}
				if (tsrStrGp[j].name == selColor) {
					xCtr++;
					break;
				}
			}
		}
		catch (e) {
		}
	}
	return xCtr;
}

// die Rahmen
var allFrames = curDoc.allPageItems;
var nFrames = allFrames.length;
var curFrame, curProps, curTransProps;
var tmpCtr;
var txtCtr = txtFill = txtStrk = txtGap = txtShw = 0;
var unaCtr = unaFill = unaStrk = unaGap = unaShw = 0;
var imgCtr = imgFill = imgStrk = imgGap = imgShw = imgCol = 0;
var linCtr = linFill = linStrk = linGap = linShw = 0;
var grpCtr = grpShw = 0;
var uknCtr = uknFill = uknStrk = uknGap = uknShw = 0;
for (var i=0; i<nFrames; i++) {
	tmpCtr = 0;
	curFrame = allFrames[i];
	curProps = curFrame.properties;
	curTransProps = "";
	if (curFrame == "[object TextFrame]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
				txtFill++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
				txtStrk++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
				txtGap++;
			}
		}
		curTransProps = curFrame.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			txtShw++;
		}
		else {
			curTransProps = curFrame.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				txtShw++;
			}
			else {
				curTransProps = curFrame.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					txtShw++;
				}
				else {
					curTransProps = curFrame.contentTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						txtShw++;
					}
				}
			}
		}
		if (tmpCtr > 0) {
			txtCtr++;
		}
	}
	else if (curFrame == "[object Rectangle]" || curFrame == "[object Oval]" || curFrame == "[object Polygon]") {
		if (curProps.contentType == 1970168179) {
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor.name == selColor) {
					tmpCtr++;
					unaFill++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
					unaStrk++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
					unaGap++;
				}
			}
			curTransProps = curProps.transparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				unaShw++;
			}
			else {
				curTransProps = curProps.strokeTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					unaShw++;
				}
				else {
					curTransProps = curProps.fillTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						unaShw++;
					}
				}
			}
			if (tmpCtr > 0) {
				unaCtr++;
			}
		}
		else {
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor.name == selColor) {
					tmpCtr++;
					imgFill++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
					imgStrk++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
					imgGap++;
				}
			}
			curTransProps = curProps.transparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				imgShw++;
			}
			else {
				curTransProps = curProps.strokeTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					imgShw++;
				}
				else {
					curTransProps = curProps.fillTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						imgShw++;
					}
				}
			}
			try {
				if (curFrame.graphics[0].properties.fillColor != undefined) {
					if (curFrame.graphics[0].properties.fillColor.name == selColor) {
						tmpCtr++;
						imgCol++;
					}
				}
			}
			catch (e) {
			}
			if (tmpCtr > 0) {
				imgCtr++;
			}
		}
	}
	else if (curFrame == "[object GraphicLine]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
				linFill++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
				linStrk++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
				linGap++;
			}
		}
		curTransProps = curProps.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			linShw++;
		}
		else {
			curTransProps = curProps.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				linShw++;
			}
			else {
				curTransProps = curProps.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					linShw++;
				}
			}
		}
		if (tmpCtr > 0) {
			linCtr++;
		}
	}
	else if (curFrame == "[object Group]") {
		// die Elemente der Gruppen sind zwei Mal vorhanden, deshalb:
		// nur die Gruppen-Effekte prfen 
		curTransProps = curProps.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			grpCtr++;
			grpShw++;
		}
	}
	else {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
				uknFill++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
				uknStrk++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
				uknGap++;
			}
		}
		curTransProps = curProps.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			uknShw++;
		}
		else {
			curTransProps = curProps.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				uknShw++;
			}
			else {
				curTransProps = curProps.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					uknShw++;
				}
			}
		}
		if (tmpCtr > 0) {
			uknCtr++;
		}
	}
}

// die Tabellen
tabCtr = 0;
var allStories = curDoc.stories;
var nStories = allStories.length;
var nTables, curTable;
var allCells, allColors, curTest, nCells;
for (var i=0; i<nStories; i++) {
	nTables = allStories[i].tables.length;
	for (var k=0; k<nTables; k++) {
		curTable = allStories[i].tables[k];
		for (var m=0; m<1; m++) {
			if (curTable.topBorderStrokeColor != undefined) {
				if (curTable.topBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeColor != undefined) {
				if (curTable.leftBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeColor != undefined) {
				if (curTable.bottomBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeColor != undefined) {
				if (curTable.rightBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.topBorderStrokeGapColor != undefined) {
				if (curTable.topBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeGapColor != undefined) {
				if (curTable.leftBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeGapColor != undefined) {
				if (curTable.bottomBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeGapColor != undefined) {
				if (curTable.rightBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			
			allCells = curTable.cells.everyItem();
			allColors = allCells.fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			
			allColors = allCells.texts[0].textStyleRanges.everyItem().fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.texts[0].textStyleRanges.everyItem().strokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			
			allColors = allCells.insertionPoints[0].fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.insertionPoints[0].strokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
		}
	}
}

// der Handler, welcher die Farben prft
function testItems(allColors) {
	var nCol = allColors.length;
	for (var c=0; c<nCol; c++) {
		try {
			if (allColors[c].name == selColor) {
				return true;
			}
		}
		catch (e) {
		}
	}
	return false;
}

// der Handler, welcher auf Schatten untersucht
function testShadow(curTransProps, selColor) {
	try {
		if (curTransProps.dropShadowSettings.effectColor != undefined) {
			if (curTransProps.dropShadowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.innerShadowSettings.effectColor != undefined) {
			if (curTransProps.innerShadowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.outerGlowSettings.effectColor != undefined) {
			if (curTransProps.outerGlowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.innerGlowSettings.effectColor != undefined) {
			if (curTransProps.innerGlowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.bevelAndEmbossSettings.shadowColor != undefined) {
			if (curTransProps.bevelAndEmbossSettings.shadowColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.bevelAndEmbossSettings.highlightColor != undefined) {
			if (curTransProps.bevelAndEmbossSettings.highlightColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.satinSettings.effectColor != undefined) {
			if (curTransProps.satinSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	return false;
}

// den Anwender informieren
var totCtr = pCtr + cCtr + oCtr + tbsCtr + cellCtr + tCtr + nCtr + rafCtr + ragCtr + rafgCtr + rbfCtr 
+ rbgCtr + rbfgCtr + iCtr + txtCtr + imgCtr + unaCtr + linCtr + grpCtr + uknCtr + tabCtr;
if (totCtr == 0) {
	alert ("Die Farbe  \"" + selColor + "\"\n\nist unauffindbar.", "Stop");
}
else {
	// die aktuelle Ebene speichern, entsperren, falls notwendig
	var lockLayer = false;
	var actLayer = app.activeWindow.activeLayer;
	if (actLayer.locked == true) {
		actLayer.locked = false;
		lockLayer = true;
	}
	
	// den Rapportrahmen entfernen (falls er vorhanden ist)
	try {
		curDoc.textFrames.item("report").remove();
	}
	catch (e) {
	}
	
	// den Ursprung auf Null/Null setzen
	curDoc.zeroPoint = [0,0];
	
	// die Zeichenformatvorgabe auf "Keine" setzen
	var noCharStyle = curDoc.characterStyles.item(0);
	curDoc.textDefaults.appliedCharacterStyle = noCharStyle;
	// die Absatzformatvorgabe auf "Einfacher Absatz" setzen
	var dfParaStyle = curDoc.paragraphStyles.item(1);
	curDoc.textDefaults.appliedParagraphStyle = dfParaStyle;
	
	// die Textkette vorbereiten
	if (totCtr == 1) {
		defString = "Gefundene Zuweisung des Farbfeldes \"" + selColor + "\":\r" + defString;
	}
	else {
		defString = "Gefundene Zuweisungen des Farbfeldes \"" + selColor + "\":\r" + defString;
	}
	
	if (tCtr > 0) {
		if (tCtr > 1) {
			defString = defString + "Textketten:\t" + tCtr + "  Textstil-Bereiche  (ohne Format; oder lokale Formatierung)\r";
		}
		else {
			defString = defString + "Textkette:\t" + tCtr + "  Textstil-Bereich  (ohne Format; oder lokale Formatierung)\r";
		}
	}
	
	if (iCtr > 0) {
		if (iCtr > 1) {
			defString = defString + "Einfgemarken:\t" + iCtr + "  (in leeren Textrahmen)\r";
		}
		else {
			defString = defString + "Einfgemarke:\t" + iCtr + "  (in leerem Textrahmen)\r";
		}
	}
	
	if (nCtr > 0) {
		if (nCtr > 1) {
			defString = defString + "Fussnoten:\t" + nCtr + " Textstil-Bereiche  (ohne Format; oder lokale Formatierung)\r";
		}
		else {
			defString = defString + "Fussnote:\t" + nCtr + " Textstil-Bereich  (ohne Format; oder lokale Formatierung)\r";
		}
	}
	
	if (rafCtr > 0) {
		if (rafCtr > 1) {
			defString = defString + "Absatzlinien:\t" + rafCtr + "  Linien darber  (Farbe)\r";
		}
		else {
			defString = defString + "Absatzlinie:\t" + rafCtr + "  Linie darber  (Farbe)\r";
		}
	}
	if (ragCtr > 0) {
		if (ragCtr > 1) {
			defString = defString + "Absatzlinien:\t" + ragCtr + "  Linien darber (nur Lcke)\r";
		}
		else {
			defString = defString + "Absatzlinie:\t" + ragCtr + "  Linie darber (nur Lcke)\r";
		}
	}
	if (rafgCtr > 0) {
		if (rafgCtr > 1) {
			defString = defString + "Absatzlinien:\t" + rafgCtr + "  Linien darber (Farbe + Lcke)\r";
		}
		else {
			defString = defString + "Absatzlinie:\t" + rafgCtr + "  Linie darber (Farbe + Lcke)\r";
		}
	}
	
	if (rbfCtr > 0) {
		if (rbfCtr > 1) {
			defString = defString + "Absatzlinien:\t" + rbfCtr + "  Linie darunter  (Farbe)\r";
		}
		else {
			defString = defString + "Absatzlinie:\t" + rbfCtr + "  Linie darunter  (Farbe)\r";
		}
	}
	
	if (rbgCtr > 0) {
		if (rbgCtr > 1) {
			defString = defString + "Absatzlinien:\t" + rbgCtr + "  Linien darunter (nur Lcke)\r";
		}
		else {
			defString = defString + "Absatzlinie:\t" + rbgCtr + "  Linie darunter (nur Lcke)\r";
		}
	}
	
	if (rbfgCtr > 0) {
		if (rbfgCtr > 1) {
			defString = defString + "Absatzlinien:\t" + rbfgCtr + "  Linien darunter (Farbe + Lcke)\r";
		}
		else {
			defString = defString + "Absatzlinie:\t" + rbfgCtr + "  Linie darunter (Farbe + Lcke)\r";
		}
	}
	
	if (txtCtr > 0) {
		defString = defString + "Textrahmen:\t" + txtCtr + "  (Fllfarbe: " + txtFill + " / Kontur: " + txtStrk + " / Lcke: " + txtGap + " / Schatten: " + txtShw + ")\r";
	}
	
	if (imgCtr > 0) {
		if (imgCol == 0) {
			defString = defString + "Bildrahmen:\t" + imgCtr + "  (Fllfarbe: " + imgFill + " / Kontur: " + imgStrk + " / Lcke: " + imgGap + " / Schatten: " + imgShw + ")\r";
		}
		else {
			defString = defString + "Bildrahmen:\t" + imgCtr + "  (Fllfarbe: " + imgFill + " / Kontur: " + imgStrk + " / Lcke: " + imgGap + " / Schatten: " + imgShw + " / Bild: " + imgCol + ")\r";
		}
	}
	
	if (unaCtr > 0) {
		defString = defString + "Ohne Inhalt:\t" + unaCtr + "  (Fllfarbe: " + unaFill + " / Kontur: " + unaStrk + " / Lcke: " + unaGap + " / Schatten: " + unaShw + ")\r";
	}
	
	if (linCtr > 0) {
		defString = defString + "Linienrahmen:\t" + linCtr + "  (Fllfarbe: " + linFill + " / Kontur: " + linStrk + " / Lcke: " + linGap + " / Schatten: " + linShw + ")\r";
	}
	
	if (grpCtr > 0) {
		defString = defString + "Gruppen:\t" + grpCtr + "  (Schatten: " + grpShw + ")\r";
	}
	
	if (uknCtr > 0) {
		defString = defString + "Unbekannte Rahmen:\t" + uknCtr + "  (Fllfarbe: " + uknFill + ", Kontur: " + uknStrk + ", Lcke: " + uknGap + ", Schatten: " + uknShw + ")\r";
	}
	
	if (tabCtr > 0) {
		defString = defString + "Tabellen:\t" + tabCtr;
	}
	
	// einen Textrahmen erzeugen ...
	var repFrame = curDoc.pages[0].textFrames.add();
	repFrame.properties = {geometricBounds:["10mm", "10mm", "285mm", "150mm"], fillColor:"Yellow", fillTint:30, label:"report"};
	repFrame.textFramePreferences.insetSpacing = ["3mm", "3mm", "6mm", "0mm"];
	// ... die vorbereitete Textkette hineinsetzen ...
	repFrame.parentStory.contents = defString;
	// ... die temporren Zeichen ersetzen ..
	app.findTextPreferences = app.changeTextPreferences = null;
	app.findTextPreferences.findWhat = ":";
	app.changeTextPreferences.changeTo = ":\u000A";
	curStory.changeText();
	app.findTextPreferences.findWhat = "";
	app.changeTextPreferences.changeTo = "";
	curStory.changeText();
	app.findTextPreferences = app.changeTextPreferences = null;
	// ... Alinieren an Grundlinienraster ausschalten, Abstand nach auf 2 mm setzen
	repFrame.parentStory.paragraphs.everyItem().properties = {alignToBaseline:false, spaceAfter:"2mm"};
	// ... eventuelle Returns am Ende entfernen ...
	try {
		for (var i=0; i<3; i++) {
			lastChar = repFrame.parentStory.characters.item(-1);
			if (lastChar.contents == "\r") {
				lastChar.remove();
			}
		}
	}
	catch (e) {
	}
	// ... an den Inhalt anpassen ...
	repFrame.fit(FitOptions.frameToContent);
	// ... und anzeigen
	app.select(repFrame,SelectionOptions.replaceWith);
	app.activeWindow.zoom = ZoomOptions.fitPage;
	app.activeWindow.zoomPercentage = 150;
	app.selection = null;
	
	// die Ebene sperren, falls notwendig
	if (lockLayer) {
		actLayer.locked = true;
	}
}